*
      SUBROUTINE PAZ_BDSV(NAME, N, NPROCS, BWL, BWU, NB, MMIN )
*
*        NB  
*          
*     PZDBSV, PZGBSV, PZPBSV
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROCS, MMIN, NB, BWL, BWU
*      , BW
      CHARACTER*(*)      NAME
*
*   -  
      INTEGER           NPR
      PARAMETER         (NPR = 6)
*
*  
      INTEGER            I, IAM, IPA, IPB, IPW, IPWOR, IPPIV,
     $                   NP, NQ, NQRHS, NRHS, NB0, WORKSIZ,
     $                   LLD_A, LLD_B, LWORK, NPROW, NPCOL
*
*  
*
*  
*
*  
*
*    NB      NPROW, NPCOL
*
      NPROW = 1
      NPCOL = NPROCS
*
      NB0 = INT(REAL( N/NPROCS ))
* + 1
      IF( NB0.LE.2 ) GO TO 10
      NB = NB0
*
*      IA=JA=IB=JB= 1
* NQRHS
      NRHS = 1
*
*
      LLD_B = NB
*
* LOCr
*      NP = LLD_A
* LOCc
      NQ = NB
*      NQRHS = NB
*
*    ( MMIN )
*
*    ()   B
      IPB = 1
*
* *NQRHS
*     A
      IPA = IPB + LLD_B*NRHS
*
      IF( NAME .NE. 'PZGBSV' ) GOTO 1
*
      LLD_A = 2*(BWL + BWU) + 1
      NP = LLD_A
*
*   ,    PZGBSV
*
      LWORK = (NB + BWU)*(BWL + BWU) + 6*(BWL + BWU)*(BWL + 2*BWU) +
     $        MAX(NRHS*(NB + 2*BWL + 4*BWU), 1)
*
*      
*   
      IPPIV = IPA + LLD_A*NB
      IPWOR = IPPIV + NB*NRHS
      GO TO 3
*
    1 IF( NAME .NE. 'PZDBSV' ) GOTO 2
*
      LLD_A = BWL + BWU + 1
      NP = LLD_A
*
*   ,    PZDBSV
*
      LWORK = NB*(BWL + BWU) + 6*MAX(BWL,BWU)*MAX(BWL,BWU) +
     $        MAX( (MAX(BWL,BWU)*NRHS), MAX(BWL,BWU)*MAX(BWL,BWU) )
*
      IPWOR = IPA + LLD_A*NB
      GO TO 3
*
    2 IF( NAME .NE. 'PZPBSV' ) GOTO 10
*
      LLD_A = BWL + 1
      NP = LLD_A
*
*   ,    PZPBSV
*
      LWORK = (NB + 2*BWL)*BWL + MAX((BWL*NRHS), BWL*BWL)
*
      IPWOR = IPA + LLD_A*NB
      GO TO 3
***
    3 IPW = IPWOR + LWORK
*
*     PZLAPRNT  .
*
      WORKSIZ = MAX( NB, NP )
*
*        
      MMIN = IPW + WORKSIZ
*
*      
*
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NPROCS
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL, MMIN
         WRITE( NPR, FMT = 9993 )NB
         WRITE( NPR, FMT = * )'   IPB,  IPA,    IPWOR,  IPW,  MMIN' 
         WRITE( NPR, FMT = 9994 )IPB, IPA, IPWOR,  IPW, MMIN
         WRITE( NPR, FMT = * )'   BWL,  BWU,    BW'
         WRITE( NPR, FMT = 9994 )BWL, BWU, BW
         WRITE( NPR, FMT = 9991 )LWORK
*
 9991 FORMAT( /'LWORK =' I5 //)
 9994 FORMAT( / 5I7 //)
*
   10 CONTINUE
*
 9992 FORMAT( / '      A X = B',
     $      '    ', A7/ )
 9998 FORMAT( /'      A ',I2,' *',I2,',',
     $       '    ',I2 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I2, ' *', I2, ';' /
     $      '      '/
     $      '    ',
     $      I5,'     '/)
 9993 FORMAT( /'     ( )',
     $       ' NB = ',I2 // '     '/)
      RETURN
      END
